#include "ti86asm.inc"
;work on the contrast and pause menu
;
;
;
;
;

.org _asm_exec_ram
start
	nop
	jp ProgStart
	.dw 0
	.dw ShellTitle
ShellTitle:
	.db "Nibblez V3.5 By Ravneet Singh!",0
_asapvar		=$d6fc
_set_abs_src_addr	=$4647
_set_abs_dest_addr	=$5285
_set_mm_num_bytes	=$464f
_mm_ldir		=$52ed
save_game:
	ld hl,_asapvar			;name of current program running
	rst 20h				;copy to OP1
	rst 10h				;_findsym
	ld a,b				;returns bde as prog data
	ld hl,data_start-_asm_exec_ram+4
					;offset in this program for start
					; of saved game data
					;2 bytes for prog length
					;2 bytes for asm identifier bytes
	add hl,de			;hl=pointer to data in original
					; prog
	adc a,$00			;in case we overlapped pages
					;if carry was set in previous
					; instruction...this will add 1 to
					; a else...it adds 0 to a
	call _set_abs_dest_addr		;set that as the absolute
					; destination address to copy to
	xor a				;no absolute addressing now
	ld hl,data_start		;*get data from here
	call _set_abs_src_addr		;set that as the absolute source
					; address to copy from
	ld hl,data_end-data_start	;*number of bytes to save
	call _set_mm_num_bytes		;set that as the number of bytes
					; to copy
	call _mm_ldir			;perform absolute address data
					; block copy
	jp _clrScrn	

ProgStart:
	call _clrLCD
	call _runindicoff
	ld a,(toloadornot)
	cp 1
	jp z,loadgame
	call gototitle
newgamefulllives:
	call OpenGray

	ld hl,25
	ld (pointsneeded),hl
	ld a,3
	ld (lives),a
	ld hl,0
	ld (dots),hl
	ld (Score),hl
newgame:
	ld a,(lives)
	cp 0
	jp z,exit

	call _clrGLCD
	call _clrLCD
	call Erasesnake
	call genarateapple
	ld a,1
	ld (SnakeX),a
	ld (SnakeX+1),a
	ld hl,SnakeX-1
	ld de,SnakeX
	ld bc,52
	ld a,1
	ld (hl),a
	ldir
	ld a,3
	ld (direction),a
	ld (Length),a

	call drawstats

	ld de,numb5
	call fade#
	ld de,numb4
	call fade#
	ld de,numb3
	call fade#
	ld de,numb2
	call fade#
	ld de,numb1
	call fade#

	call drawstats
	call pickurtile
	call Drawgraytiles

topcheck:

	ld a,%10111111
	out (1),a
	nop
	nop
	in a,(1)
	bit 6,a
	jp z,exit


	call scandirection

	ld a,%11111101 
	out (1),a
	nop
	nop
	in a,(1)
	bit 2,a
	call z,decrease_contrast

	ld a,%11111101 
	out (1),a
	nop
	nop
	in a,(1)
	bit 1,a
	call z,increase_contrast

	ld a,%10111111  
	out (1),a
	nop
	nop
	in a,(1)
	bit 7,a
	jp z,saveandexit

	call scanforapples
	call movetail

	ld a,1
	ld (keycheck),a

	call Slowdown
	call nextlevel
	jr topcheck
fade#:
	push de
	ld hl,$fc00+(16*30)+7
	ld b,8
	call topDrawGray1
	pop de
	push de
	ld hl,$ca00+(16*30)+7
	ld b,8
	call topDrawGray1
	call haltcall

	ld hl,$ca00+(16*30)+7
	call clrslect
	ld hl,$fc00+(16*30)+7
	call clrslect
	pop de

	push de
	ld hl,$fc00+(16*30)+7
	ld b,8
	call topDrawGray1
	call haltcall
	ld hl,$ca00+(16*30)+7
	call clrslect
	ld hl,$fc00+(16*30)+7
	call clrslect
	pop de

	ld hl,$ca00+(16*30)+7
	ld b,8
	call topDrawGray1
	call haltcall


	ld hl,$ca00+(16*30)+7
	call clrslect
	ld hl,$fc00+(16*30)+7
	call clrslect
	call haltcall

	ret
clrslect:
	ld b,8
	ld a,0
	ld de,16
topclrslect:
	ld (hl),a
	add hl,de
	djnz topclrslect
	ret

haltcall:
	ld b,20
tophaltcall:
	halt
	djnz tophaltcall
	ret

keycheck: .db 0
loadgame:
	call pickurtile
	ld a,0
	ld (toloadornot),a
	call save_game2
	call _clrLCD
	call _clrGLCD
	call OpenGray
	call drawstats
	call pickurtile
	call Drawgraytiles
	jp topcheck
saveandexit:
	ld a,1
	ld (toloadornot),a
	call save_game2
	call CloseGray
	call _clrLCD
	ld hl,(256*0)+0
	ld (_curRow),hl
	ret
scandirection:
	ld a,%11111110 
	out (1),a
	nop
	nop
	in a,(1)
	bit 2,a
	jp z,moveright

	ld a,%11111110 
	out (1),a
	nop
	nop
	in a,(1)
	bit 1,a
	jp z,moveleft

	ld a,%11111110 
	out (1),a
	nop
	nop
	in a,(1)
	bit 3,a
	jp z,moveup

	ld a,%11111110 
	out (1),a
	nop
	nop
	in a,(1)
	bit 0,a
	jp z,movedown
	ret
nextlevel:
;pop = 1
;ret = 1

	ld a,(loadnewlevel)
	cp 0 
	ret z
	ld hl,(pointsneeded)
	ld de,(dots)
	call _cphlde
	ret nz
	ld hl,(pointsneeded)
	ld de,25
	add hl,de
	ld (pointsneeded),hl

	ld a,(currlevel)
	cp 20
	ret z
	inc a
	ld (currlevel),a
	ld b,a
	ld a,(maxusermap)
	dec a
	cp b
	call c,newuserlevel

	ld hl,(currentleveladdress)
	ld bc,56
	add hl,bc
	ld (currentleveladdress),hl
	call loadmap

	pop hl
	jp newgame
newuserlevel:
	ld a,(currlevel)
	ld (maxusermap),a
	call save_game
	ret
exit:
	ld a,0
	ld (toloadornot),a
	call save_game2

	ld de,(SnakeX)
	ld hl,(256*0)+0
	ld (_curRow),hl
	call CloseGray
	ld de,(Score)
	ld (PlayerScore),de
	ld hl,(Score8r)
	call _cphlde
	call c,Typethehighscores
	call gototitle

moveright:
	ld a,(direction)
	cp 3
	ret z
	cp 2
	ret z

	ld a,(keycheck)
	cp 1
	ret nz
	ld a,3
	ld (direction),a
	ld a,0
	ld (keycheck),a
	ret

moveleft:
	ld a,(direction)
	cp 2
	ret z
	cp 3
	ret z

	ld a,(keycheck)
	cp 1
	ret nz

	ld a,2
	ld (direction),a
	ld a,0
	ld (keycheck),a
	ret

moveup:
	ld a,(direction)
	cp 0
	ret z
	cp 1
	ret z
	ld a,(keycheck)
	cp 1
	ret nz
	ld a,0
	ld (direction),a
	ld (keycheck),a
	ret

movedown:
	ld a,(direction)
	cp 1
	ret z
	cp 0
	ret z
	ld a,(keycheck)
	cp 1
	ret nz
	ld a,1
	ld (direction),a
	ld a,0
	ld (keycheck),a
	ret

Erasedot:
	push de
;hl=videomem-$fc00
	ld hl,$10*12
	ld a,e
	ld e,0
topErasedot1:
	cp 2
	jr c,nextErasedot
	dec a
	dec a
	inc e
	jr topErasedot1
nextErasedot:
	ld c,e;rows set
	ld b,0
	add hl,bc

	ld bc,$40
	ld a,d	
topErasedot2:
	dec a
	cp 0
	jr z,nextErasedot1
	add hl,bc
	jr topErasedot2
nextErasedot1:

	call blank
	pop de

	ld bc,SnakeMap
	ld h,0
	ld l,d
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	ld c,e
	ld b,0
	add hl,bc
	ld a,0
	ld (hl),a
	ret
Drawdot:
	push de
;hl=videomem-$fc00
	ld hl,$10*12
	ld a,e
	ld e,0
topDrawdot1:
	cp 2
	jr c,nextDrawdot
	dec a
	dec a
	inc e
	jr topDrawdot1
nextDrawdot:
	ld c,e;rows set
	ld b,0
	add hl,bc

	ld bc,$40
	ld a,d	
topDrawdot2:
	dec a
	cp 0
	jr z,nextDrawdot1
	add hl,bc
	jr topDrawdot2
nextDrawdot1:

	pop de
	push de

	ld a,e
	and %00000001
	jr nz,otherDrawdot

;de=sprite
;hl=address

	ld de,tile3
	call DrawGray
	jr back1Drawdot


otherDrawdot:
	ld de,tile4
	call DrawGray

back1Drawdot:
	pop de
drawdothalf:
	ld bc,SnakeMap
	ld h,0
	ld l,d
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl

	add hl,bc
	ld c,e
	ld b,0
	add hl,bc
	call ldA3or4
	ld (hl),a
	ret
ldA3or4:
	ld a,e
	ld e,1
	ld b,0
topldA3or4:
	cp e
	jp z,is3
	inc e
	inc e
	djnz topldA3or4
	ld a,3
	ret
is3:
	ld a,4
	ret
Drawgraytiles:
	ld de,SnakeMap
	ld hl,$10*8
	ld b,14
topDrawgraycols:
		push bc
		ld b,16
topDrawgrayrows:
			push bc
				push hl
					push de
					call DrawGrayTableTile
					ld a,(curroddoreven)
					inc a
					ld (curroddoreven),a
					pop de
				pop hl
	
				inc  de

				push hl
					push de
					call DrawGrayTableTile
					ld a,(curroddoreven)
					inc a
					ld (curroddoreven),a
					pop de
				pop hl
				inc hl
				inc de
			pop bc
		djnz topDrawgrayrows
		ld bc,64-16
		add hl,bc
		pop bc
	djnz topDrawgraycols
	ret

DrawGrayTableTile:
;de=map
;hl=address
	push hl
	ld a,(de)
	cp 0
	jp z,exot
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld de,tile0
	add hl,de
	ld d,h
	ld e,l
	pop hl
	call DrawGray
	ret
exot:
	pop hl
	ret
blank:
	ld a,(totest)
	ld e,1
	ld b,0
topldA3or41
	cp e
	jp z,blankr
	inc e
	inc e
	djnz topldA3or41

blankl:
	ld bc,$fc00
	push hl
	add hl,bc
	ld b,4
topblankl:
	ld a,(hl)
	cpl
	or %11110000
	cpl
	ld (hl),a
	ld de,$10
	add hl,de
	djnz topblankl

	pop hl

	ld bc,$ca00
	add hl,bc
	ld b,4
topblankl1:
	ld a,(hl)
	cpl
	or %11110000
	cpl
	ld (hl),a
	ld de,$10
	add hl,de
	djnz topblankl1
	ret

blankr:
	ld bc,$fc00
	push hl
	add hl,bc
	ld b,4
topblankr:
	ld a,(hl)
	cpl
	or %00001111
	cpl
	ld (hl),a
	ld de,$10
	add hl,de
	djnz topblankr

	pop hl

	ld bc,$ca00
	add hl,bc
	ld b,4
topblankr1:
	ld a,(hl)
	cpl
	or %00001111
	cpl
	ld (hl),a
	ld de,$10
	add hl,de
	djnz topblankr1
	ret

movetail:
	ld bc,(SnakeX)
	push bc
	call movethbytes
	pop bc
	ld (SnakeX),bc
	ld a,(direction)
	cp 0
	jp z,moveupsnake
	cp 1
	jp z,movedownsnake
	cp 2
	jp z,moveleftsnake
	cp 3
	jp z,moverightsnake
back1:
	ld de,(SnakeX)
	call Drawdot

	ld a,(Length)
	ld b,a
	ld hl,SnakeX
topmovetail:
		push bc
		ld e,(hl)
		inc hl
		ld d,(hl)
			push hl
			ld a,h
			ld (totest),a
;			call drawdothalf
			pop hl
		inc hl
		pop bc
	djnz topmovetail

	ld e,(hl)

	ld a,e
	ld (totest),a

	inc hl
	ld d,(hl)
		push hl
		call Erasedot
		pop hl
	inc hl

	ret
Drawsnakeonly:
	


moverightsnake:
	ld de,(SnakeX)
	inc e
	call checkobject
	call checkobjectandact
	ld a,(SnakeX)
	inc a
	ld (SnakeX),a
	jp back1
moveleftsnake:
	ld de,(SnakeX)
	dec e
	call checkobject
	call checkobjectandact
	ld a,(SnakeX)
	dec a
	ld	(SnakeX),a
	jp back1
moveupsnake:
	ld de,(SnakeX)
	dec d
	call checkobject
	call checkobjectandact
	ld a,(SnakeY)
	dec a
	ld	(SnakeY),a
	jp back1
movedownsnake:
	ld de,(SnakeX)
	inc d
	call checkobject
	call checkobjectandact
	ld a,(SnakeY)
	inc a
	ld	(SnakeY),a
	jp back1
checkobjectandact:
	cp 3
	call z,crashed
	cp 4
	call z,crashed
	cp 1
	call z,crashed
	cp 2
	call z,crashed
	cp 5
	call z,incdot
	cp 6
	call z,incdot
	cp 7
	call z,genarateapple1
	cp 8
	call z,genarateapple1
	cp 9
	call z,inclife
	cp 10
	call z,inclife
	ret
genarateapple1:
	ld hl,(Score)
	ld de,100
	add hl,de
	ld (Score),hl
	call drawstats
	jp genarateapple

inclife:
	ld hl,(Score)
	ld de,50
	add hl,de
	ld (Score),hl

	ld a,(lives)
	cp 50
	ret z
	inc a
	ld (lives),a
	call drawstats
	ret


incdot:
	ld hl,(dots)
	inc hl
	ld (dots),hl

	ld hl,(Score)
	ld a,(Speed)
	ld e,a
	ld d,0
	add hl,de
	ld (Score),hl

	ld a,(Length)
	cp 100
	jr z,skipcrap
	inc a
	ld (Length),a
skipcrap:
	call genarateapple
	call drawstats
	ret
crashed:
	ld a,(lives)
	dec a
	ld (lives),a
	pop hl
	pop hl
	pop hl
	jp newgame
movethbytes:
	ld hl,(SnakeX)
	push hl
	ld hl,blockcordsend
	ld de,blockcordsend+1
	ld bc,202
	lddr
	ld hl,blockcordsend
	ld de,blockcordsend+1
	ld bc,202
	lddr
	pop hl
	ld (SnakeX),hl
	ret
checkobject:
	ld bc,SnakeMap
	ld h,0
	ld l,d
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl

	add hl,bc
	ld c,e
	ld b,0
	add hl,bc
	ld a,(hl)
	ret
gamespeedcounter: .dw 0
gogogo: .db 0
timetogo:
	ld a,1
	ld (gogogo),a
	ld de,0
	ld (gamespeedcounter),de
	ret
returnback:
	ld a,0
	ld (gogogo),a
	ret
ravcpdehl:
	ld b,h
	ld a,d
	cp b
	ret nz
	ld b,l
	ld a,e
	cp b
	ret
incmaingamecounter:
	ld a,(gogogo)
	cp 1
	ret z
	ld a,(Speed)
	ld b,a
	ld a,30
	sub b
	ld de,1
	ld hl,0
topincmaingamecounter
	cp 0
	jr z,exitincmaingamecounter
	dec a
	add hl,de
	jr topincmaingamecounter

exitincmaingamecounter:
	ld de,(gamespeedcounter)

	call ravcpdehl

	jr z,timetogo
	inc de
	ld (gamespeedcounter),de
	ret

Slowdown:
	call scandirection
	ld a,(gogogo)
	cp 1
	jr z,returnback
	jr Slowdown


drawstats:
	ld hl,titledots
	ld bc,0
	ld (_penCol),bc
	call _vputs

	ld hl,(dots)
;	ld bc,20
;	ld (_penCol),bc
	call DispHL


	ld hl,titlelives
;	ld bc,35
;	ld (_penCol),bc
	call _vputs

	ld a,(lives)
	ld h,0
	ld l,a
;	ld bc,53
;	ld (_penCol),bc
	call DispHL



	ld hl,titlescore
;	ld bc,35
;	ld (_penCol),bc
	call _vputs

	ld hl,(Score)
;	ld bc,53
;	ld (_penCol),bc
	call DispHL

	ld hl,$fc00
	ld de,$ca00
	ld bc,$10*8
	
	ldir
	ret
genarateapple:
	ld a,(randsto)
	ld b,a
	ld a,r
	add a,b
	ld (randsto),a
	cp 12
	jr nc,genarateapple
	cp 1
	jr z,genarateapple
	ld d,a
rand30:
	ld a,(randsto)
	ld b,a
	ld a,r
	add a,b
	ld (randsto),a
	cp 30
	jr nc,rand30
	cp 1
	jr z,rand30
	ld e,a
	push de
	call checkobject
	pop de
	cp 0
	jr nz,genarateapple
	call Drawapple

	ld a,(randsto)
	ld b,a
	ld a,r
	add a,b
	ld (randsto),a
	and %00001111
	cp 7
	call z,genaratespecial
	call Drawgraytiles

	ret
Drawapple:
;de=cords
	ld bc,SnakeMap
	ld h,0
	ld l,d
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl

	add hl,bc
	ld c,e
	ld b,0
	add hl,bc
	call ldA5or6
	ld (hl),a
	ret
ldA5or6:
	ld a,e
	ld e,1
	ld b,0
topldA5or6:
	cp e
	jp z,is5
	inc e
	inc e
	djnz topldA5or6
	ld a,5
	ret
is5:
	ld a,6
	ret

genaratespecial:
	ld a,(loadnewlevel)
	cp 0 
	ret z
	ld a,(randsto)
	ld b,a
	ld a,r
	add a,b
	ld (randsto),a
	cp 12
	jr nc,genaratespecial
	cp 1
	jr z,genaratespecial
	ld d,a
rand303:
	ld a,(randsto)
	ld b,a
	ld a,r
	add a,b
	ld (randsto),a
	cp 30
	jr nc,rand303
	cp 1
	jr z,rand303
	ld e,a
	push de
	call checkobject
	pop de
	cp 0
	jr nz,genaratespecial
	call Drawspecial
	ret


Drawspecial:
;de=cords
	ld bc,SnakeMap
	ld h,0
	ld l,d
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl

	add hl,bc
	ld c,e
	ld b,0
	add hl,bc
	ld a,e
	bit 0,a
	jr z,oddnumber
	ld a,8
	push af
	ld a,r
	bit 0,a
	pop af
	jr z,oddreturn
	ld a,10

oddreturn:
	ld (hl),a
	ret


oddnumber:
	ld a,7
	push af
	ld a,r
	bit 0,a
	pop af
	jr z,oddreturn
	ld a,9
	jr oddreturn

scanforapples:
	ld bc,SnakeMap
	ld de,448
topscanforapples:
	ld a,(bc)
	cp 5
	ret z
	cp 6
	ret z

	inc bc
	dec de
	ld hl,0
	call _cphlde
	jp z,genarateapple
	jr topscanforapples
	


Erasesnake:
	ld bc,SnakeMap
	ld de,448
topErase:
	ld a,(bc)
	cp 3
	jp z,erase
	cp 4
	jp z,erase
	cp 5
	jp z,erase
	cp 6
	jp z,erase
back23:
	inc bc
	dec de
	ld hl,0
	call _cphlde
	ret z
	jr topErase
erase:
	ld a,0
	ld (bc),a
	jr back23


DispHL:					;dipslay 5 digits from hl
 xor a
 ld de,-1
 ld (_curRow),de
 call 4A33h
 dec hl
 jp skipspacesanddrawtozero


skipspacesanddrawtozero:
	ld a,(hl)
	cp 0
	ret z
	cp ' '
	jr z,skipdrawstring
	push hl
	call _vputmap
	pop hl
skipdrawstring:
	inc hl
	jr skipspacesanddrawtozero



Typethehighscores:
	call _clrLCD
	call _clrGLCD
	ld a,0
	ld (currpos),a
	ld hl,Congratulations
	ld bc,(256*0)+30
	ld (_penCol),bc
	call _vputs
	ld hl,ugotscore
	ld bc,(256*6)+27
	ld (_penCol),bc
	call _vputs
	ld hl,BoardSetupName
	ld bc,(256*12)+0
	ld (_penCol),bc
	call _vputs
	ld a,0
	ld (currpos),a
	call toptypekey
	call wherescoregoes
	call adjustcopy
	call save_game
DisplayHighScore:
	call turntextwhite

	call _clrLCD
	call _clrGLCD

	call OpenGray
	ld hl,Name
	ld bc,(256*0)+20
	ld (_penCol),bc
	call _vputs

	ld hl,BoardSetupName
	ld bc,(256*6)+0
	ld (_penCol),bc
	call _vputs

	ld hl,BoardSetupScore
	ld bc,(256*6)+100
	ld (_penCol),bc
	call _vputs

	ld hl,Score1
	ld bc,(256*12)+0
	ld (_penCol),bc

	call _vputs
	ld d,7
topHighScoreName:
	inc hl
	inc hl
	inc b
	inc b
	inc b
	inc b
	inc b
	inc b
	ld (_penCol),bc
	call _vputs
	dec d
	ld a,d
	cp 0
	jp nz,topHighScoreName

	ld de,Score1+15
	ld bc,(256*12)+100
	ld (_penCol),bc
	ld b,8
tophighscoredisphl:
	push bc

	ld a,(de)
	ld l,a
	inc de
	ld a,(de)
	ld h,a
	push hl
	ld hl,16
	add hl,de
	ld e,l	
	ld d,h
	pop hl

	push de
	call DispHL
	pop de

	ld a,100
	ld (_penCol),a
	ld a,(_penCol+1)
	ld b,6
	add a,b
	ld (_penCol+1),a


	pop bc
	djnz tophighscoredisphl

	ld hl,$fc00+$60
	ld de,$ca00+$60
	ld bc,$60
	ldir

	ld hl,$fc00+($60*3)
	ld de,$ca00+($60*3)
	ld bc,$60
	ldir

	ld hl,$fc00+($60*5)
	ld de,$ca00+($60*5)
	ld bc,$60
	ldir

	ld hl,$fc00+($60*7)
	ld de,$ca00+($60*7)
	ld bc,$60
	ldir

	ld hl,$fc00+($60*9)
	ld de,$ca00+($60*9)
	ld bc,$60
	ldir

	call _gpause
	call CloseGray
	ret
copybytes:
;hl = copy from
;de = copy to
;b = Number of bytes
	ld a,(de)
	ld c,a ;(de)=c

	ld a,(hl);(hl)=a
	ld (de),a

	ld a,c
	ld (hl),a
	inc hl
	inc de
	djnz copybytes
	ret



toptypekey:
	ld hl,Tempname
	ld a,12
	ld (_penRow),a
	ld a,21
	ld (_penCol),a
	call DispStr

	call _getky
	cp 0
	jp z,toptypekey
	cp K_ENTER
	ret z
	cp K_ALPHA
	jp z,alpha
	cp K_DEL
	jp z,backspace
	cp K_LEFT
	jp z,backspace
	cp K_RIGHT
	jp z,forwardspace
bacatu:
	ld e,a
	ld a,(trueal)
	cp 1
	jp z,alpha_on
	ld hl,keychart
nextright:

	ld a,e

	ld c,a
	ld b,0
	add hl,bc

	ld bc,Tempname	

	ld a,(hl)
	ld e,a

	ld a,(currpos)
	ld h,0
	ld l,a
	add hl,bc

	ld a,e
	ld (hl),a

	ld hl,Tempname

	ld a,12
	ld (_penRow),a
	ld a,21
	ld (_penCol),a
	call DispStr

	ld a,(currpos)
	cp 13
	ret z
	ld a,(currpos)
	inc a
	ld (currpos),a
	jp toptypekey
storetempleter:
.db 0,0
storetemplocation: .db 0

DispStr:;hl=the string loc ends at the 0 byte
	ld a,0
	ld (storetemplocation),a
RavDispStr:
	push hl
	ld a,(storetemplocation)
	ld b,a
	ld a,(currpos)
	cp b
	call z,turntextblack

	ld a,(storetemplocation)
	ld b,a
	ld a,(currpos)
	cp b
	call nz,turntextwhite
	pop hl

	ld a,(hl)
	call displayaincline
	inc hl
	ld a,(hl)
	cp 0
	ret z
	ld a,(storetemplocation)
	inc a
	ld (storetemplocation),a

	jr RavDispStr
displayaincline:
	push hl
	ld (storetempleter),a
	ld hl,storetempleter
	call _vputs
	pop hl
	ret
forwardspace:
	ld a,(currpos)
	cp 13
	jp z,toptypekey
	inc a
	ld (currpos),a
	jp toptypekey

backspace:
	ld a,(currpos)
	cp 0
	jp z,toptypekey
	dec a
	ld (currpos),a
	jp toptypekey
	
alpha:
	ld a,(trueal)
	cp 1
	jp z,nonalpha
	ld a,1
	ld (trueal),a
	jp toptypekey
nonalpha:
	ld a,0
	ld (trueal),a
	jp toptypekey


alpha_on:
	ld hl,alphakeychart
	jp nextright
wherescoregoes:
	ld de,(PlayerScore)
	ld a,0
	ld hl,(Score1r)
	call _cphlde
	jr c,nextscore
	ld a,1
	ld hl,(Score2r)
	call _cphlde
	jr c,nextscore
	ld a,2
	ld hl,(Score3r)
	call _cphlde
	jr c,nextscore
	ld a,3
	ld hl,(Score4r)
	call _cphlde
	jr c,nextscore
	ld a,4
	ld hl,(Score5r)
	call _cphlde
	jr c,nextscore
	ld a,5
	ld hl,(Score6r)
	call _cphlde
	jr c,nextscore
	ld a,6
	ld hl,(Score7r)
	call _cphlde
	jr c,nextscore
	ld a,7
	ld hl,(Score8r)
	call _cphlde
	jr c,nextscore

	jr scoretoolow
nextscore:
	ld ($8000),a
	ret 
scoretoolow:
	ld a,255
	ld ($8000),a
	call _pause
	ret
adjustcopy:
	ld a,($8000)
	cp 255
	ret z
	cp 0
	jp z,first
	cp 1
	jp z,second
	cp 2
	jp z,third
	cp 3
	jp z,fourth
	cp 4
	jp z,fifth
	cp 5
	jp z,sixth
	cp 6
	jp z,seventh
	cp 7
	jp z,eighth
	ret
first:
	ld hl,Score1
	ld de,Tempname
	ld b,17
	call copybytes
second:
	ld hl,Score2
	ld de,Tempname
	ld b,17
	call copybytes
third:
	ld hl,Score3
	ld de,Tempname
	ld b,17
	call copybytes
fourth:
	ld hl,Score4
	ld de,Tempname
	ld b,17
	call copybytes
fifth:
	ld hl,Score5
	ld de,Tempname
	ld b,17
	call copybytes
sixth:
	ld hl,Score6
	ld de,Tempname
	ld b,17
	call copybytes
seventh:
	ld hl,Score7
	ld de,Tempname
	ld b,17
	call copybytes
eighth:
	ld hl,Score8
	ld de,Tempname
	ld b,17
	call copybytes
	ret

_gpause:
	ld a,%11111101  
	out (1),a
	nop
	nop
	in a,(1)
	bit 0,a
	ret z
	jr _gpause
topcopyone:
	ld b,10
ttopcopyone:
	push bc

	ld b,5
tttopcopyone:
	ld a,(de)
	ld (hl),a
	inc hl
	inc de
	djnz tttopcopyone
	ld bc,11
	add hl,bc

	pop bc
	djnz ttopcopyone
	ret
turntextblack:
	ld a,($c3e5+5)
	or %00001000
	ld ($c3e5+5),a
	ret
turntextwhite:
	ld a,($c3e5+5)
	cpl
	or %00001000
	cpl
	ld ($c3e5+5),a
	ret

maintitle: 
gototitle:
	call OpenGray
	call _clrLCD
	call _clrGLCD

	call turntextblack
	ld hl,(256*0)+0
	ld (_curRow),hl
	ld hl,DispNibblez
	call _puts
	ld hl,(256*58)+0
	ld (_penCol),hl
	ld hl,DispName
	call _vputs
	call turntextwhite

	ld hl,$fc00
	ld de,$ca00
	ld bc,1024
	ldir
	
	call drawalloptions
	call loadmapaddresses

top:
	ld a,%10111111   
	out (1),a
	nop
	nop
	in a,(1)
	bit 5,a
	call z,enterpressed

	ld a,%11111110 
	out (1),a
	nop
	nop
	in a,(1)
	bit 1,a
	call z,moveleft1

	ld a,%11111110 
	out (1),a
	nop
	nop
	in a,(1)
	bit 2,a
	call z,moveright1

	ld a,%11111110 
	out (1),a
	nop
	nop
	in a,(1)
	bit 3,a
	call z,moveup1

	ld a,%11111110 
	out (1),a
	nop
	nop
	in a,(1)
	bit 0,a
	call z,movedown1

	halt
	halt
	halt

	jp top
enterpressed:
	ld a,(toturnblack)
	cp 1
	call z,newgamestart
	ld a,(toturnblack)
	cp 8
	call z,Quit
	ld a,(toturnblack)
	cp 7
	jp z,tttDisplayHighScore
	ld a,(toturnblack)
	cp 6
	jp z,myinfo
	ld a,(toturnblack)
	cp 5
	call z,chnglvlornot

	ld a,(toturnblack)
	cp 4
	call z,nextstring

	ret
chnglvlornot:
	ld a,(loadnewlevel)
	inc a
	and %00000001
	ld (loadnewlevel),a

	ld hl,dispclear2
	ld bc,256*32+35
	ld (_penCol),bc
	call _vputs


	call drawalloptions
	ret
moveleft1:
	ld a,(toturnblack)
	cp 3
	call z,decreasemapnumb

	ld a,(toturnblack)
	cp 2
	call z,decspeed

	ret
moveright1:
	ld a,(toturnblack)
	cp 3
	call z,increasemapnumb

	ld a,(toturnblack)
	cp 2
	call z,changespeed

	ret
stopupbutton:
	ld a,%11111110 
	out (1),a
	nop
	nop
	in a,(1)
	bit 3,a
	halt
	jr z,stopupbutton
	ret
stopdownbutton:
	ld a,%11111110 
	out (1),a
	nop
	nop
	in a,(1)
	bit 0,a
	halt
	jr z,stopdownbutton
	ret
moveup1:

	ld a,(toturnblack)
	cp 1
	jr z,gostartdown
	dec a
	ld (toturnblack),a
	call drawalloptions
	call stopupbutton
	ret
movedown1:

	ld a,(toturnblack)
	cp 8
	jr z,gostartup
	inc a
	ld (toturnblack),a
	call drawalloptions
	call stopdownbutton
	ret
gostartup:
	ld a,1
	ld (toturnblack),a
	call drawalloptions
	call stopdownbutton
	ret
gostartdown:
	ld a,8
	ld (toturnblack),a
	call drawalloptions
	call stopupbutton
	ret
toturnblack: .db 1
drawalloptions:

	ld hl,(256*8)+0
	ld (_penCol),hl
	ld hl,dispnewgame
	call _vputs
	ld a,(toturnblack)
	cp 1
	call turnblack



	ld hl,(256*14)+0
	ld (_penCol),hl
	ld hl,dispspeed
	call _vputs

	ld a,207
	call _vputmap


	ld a,(Speed)
	ld h,0
	ld l,a
	call DispHL

	ld a,5
	call _vputmap

	ld a,(toturnblack)
	cp 2
	call turnblack

	ld hl,(256*20)+0
	ld (_penCol),hl
	ld hl,displevel
	call _vputs

	ld a,207
	call _vputmap


	ld a,(tempslectmap)
	ld h,0
	ld l,a
	call DispHL

	ld a,5
	call _vputmap



	ld a,(toturnblack)
	cp 3
	call turnblack

	ld hl,(256*26)+0
	ld (_penCol),hl
	ld hl,dispString
	call _vputs

	ld a,207
	call _vputmap

	ld hl,stringtoload+1
	ld a,(stringtoload)
	ld b,a
	call _vputsn

	ld a,5
	call _vputmap

	ld a,(toturnblack)
	cp 4
	call turnblack

	ld hl,(256*32)+0
	ld (_penCol),hl
	ld hl,dispchangelvl
	call _vputs

	ld a,(loadnewlevel)
	cp 0
	jr z,dispdontchange

	ld hl,Dispyes
	call _vputs
	jr backdontchange

dispdontchange:
	ld hl,Dispno
	call _vputs

backdontchange
	ld a,(toturnblack)
	cp 5
	call turnblack

	ld hl,(256*38)+0
	ld (_penCol),hl
	ld hl,dispinfo
	call _vputs
	ld a,(toturnblack)
	cp 6
	call turnblack

	ld hl,(256*44)+0
	ld (_penCol),hl
	ld hl,disphighscore
	call _vputs
	ld a,(toturnblack)
	cp 7
	call turnblack

	ld hl,(256*50)+0
	ld (_penCol),hl
	ld hl,dispquit
	call _vputs
	ld a,(toturnblack)
	cp 8
	call turnblack
	call drawcurrlevel
	ret
displevel: .db "Level:",0
dispString: .db "String:",0
dispquit: .db "Quit",0
turnlightgray:
	ld a,(_penCol+1)
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld de,$fc00
	add hl,de
	push hl
	ld a,(_penCol+1)
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld de,$ca00
	add hl,de
	ld e,l
	ld d,h
	pop hl

	ld b,6
toptopturnlightgray:
	push bc
	ld b,7
topturnlightgray:
	ld a,(hl)
	ld (de),a
	ld a,0
	ld (hl),a
	inc hl
	inc de
	djnz topturnlightgray
	ld bc,9
	add hl,bc

	push hl
	ld h,d
	ld l,e
	add hl,bc
	ld d,h
	ld e,l
	pop hl

	pop bc
	djnz toptopturnlightgray
	ret

turnblack:
	jp nz,turnlightgray
	ld a,(_penCol+1)
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld de,$fc00
	add hl,de
	push hl
	ld a,(_penCol+1)
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld de,$ca00
	add hl,de
	ld e,l
	ld d,h
	pop hl

	ld b,6
toptopturnblack:
	push bc
	ld b,7
topturnblack:
	ld a,(hl)
	ld (de),a
	inc hl
	inc de
	djnz topturnblack
	ld bc,9
	add hl,bc
	push hl
	ld h,d
	ld l,e
	add hl,bc
	ld d,h
	ld e,l
	pop hl
	pop bc
	djnz toptopturnblack
	ret
DispNibblez: .db "    Nibblez v3.5     ",0
DispName: .db " Ravneet Singh        thecheatah@aol.com",0

DispChooselev:	.db "Select a level:",0
dispchangelvl:	.db "Change lvl:",0
Dispyes: .db "Yes",0
Dispno: .db "No",0

increasemapnumb:
	ld a,(tempslectmap)
	cp 20
	ret z
	ld b,a
	ld a,(maxusermap)
	cp b
	ret z
	ld a,(tempslectmap)
	inc a
	ld (tempslectmap),a


	ld hl,dispclear2
	ld bc,256*20+30
	ld (_penCol),bc
	call _vputs

	call drawalloptions
	call loadmapaddresses
	ret
	
decreasemapnumb:
	ld a,(tempslectmap)
	cp 1
	ret z
	dec a
	ld (tempslectmap),a


	ld hl,dispclear2
	ld bc,256*20+30
	ld (_penCol),bc
	call _vputs

	call drawalloptions
	call loadmapaddresses


	ret
loadmapaddresses:
	ld a,(tempslectmap)
	ld (currlevel),a
toploadmapaddresses:
	cp 0
	jr z,exitloadmapaddresses

	ld hl,SnakeLevel1
	ld bc,56
	add hl,bc
	dec a
	jr toploadmapaddresses
exitloadmapaddresses:

	ld (currentleveladdress),hl
	ret
tempslectmap: .db 1
topcopyone1:
	ld b,14
ttopcopyone1:
	push bc

	ld b,4
tttopcopyone1:
	ld a,(de)
	ld (hl),a
	inc hl
	inc de
	djnz tttopcopyone1
	ld bc,12
	add hl,bc

	pop bc
	djnz ttopcopyone1
	ret

drawcurrlevel:
	ld a,(tempslectmap)
	ld hl,SnakeLevel1-56
	ld de,56
	ld b,a
topslectedlevel1:
	add hl,de
	djnz topslectedlevel1
	ld d,h
	ld e,l
	ld hl,$fd79
	push de
	call topcopyone1
	pop de
	ld hl,$cb79
	call topcopyone1	
	ret 

Quit:
	pop hl
	pop hl
	pop hl
	call CloseGray
	ld a,0
	ld (toloadornot),a
	call save_game2
	call _clrLCD
	ld hl,(256*0)+0
	ld (_curRow),hl
	ret

tttDisplayHighScore:

	call DisplayHighScore
	pop hl
	jp gototitle

decspeed:
	ld a,(Speed)
	cp 0
	ret z
	dec a
	ld (Speed),a

	ld hl,dispclear2
	ld bc,256*14+30
	ld (_penCol),bc
	call _vputs
	call drawalloptions
	ret	

changespeed:
	ld a,(Speed)
	cp 30
	ret z
	inc a
	ld (Speed),a
	ld hl,dispclear2
	ld bc,256*14+30
	ld (_penCol),bc
	call _vputs
	call drawalloptions
	ret	


newgamestart:
	call LoadString
	ld a,(tempslectmap)
	ld (currlevel),a
	ld hl,SnakeLevel1-56
	ld de,56
	ld b,a
topslectedlevel:
	add hl,de
	djnz topslectedlevel


	ld (currentleveladdress),hl
	call loadmap

	pop hl
	pop hl
	pop hl
	jp newgamefulllives


_clrGLCD
	ld hl,$ca00
	ld de,$ca01
	ld bc,$3ff
	ld a,0
	ld (hl),a
	ldir
	ret
myinfo:
	call CloseGray
	call _clrLCD
	ld hl,infoline1
	ld bc,256*0+0
	ld (_penCol),bc
	call _vputs

	ld hl,infoline2
	ld bc,256*6+0
	ld (_penCol),bc
	call _vputs

	ld hl,infoline3
	ld bc,256*12+0
	ld (_penCol),bc
	call _vputs

	ld hl,infoline4
	ld bc,256*18+0
	ld (_penCol),bc
	call _vputs

	ld hl,infoline5
	ld bc,256*24+0
	ld (_penCol),bc
	call _vputs
topgggg:
	call _getky
	cp 0
	jr z,topgggg
	call _clrLCD
	pop hl
	call OpenGray
	jp gototitle
	

_contrast	=$c008		;where contrast is stored
contrast_port	=2		;port controlling contrast

increase_contrast:
	ld hl,_contrast		;address of contrast
	ld a,(hl)		;get contrast
	cp 31			;compare it to max
	ret z			;it was 31 so return
	inc a			;increase contrast
	ld (hl),a		;put back changes
	out (contrast_port),a	;update contrast
	ret

decrease_contrast:
	ld hl,_contrast		;address of contrast
	ld a,(hl)		;get contrast
	cp 1			;compare it to max
	ret z			;it was 31 so return
	dec a			;increase contrast
	ld (hl),a		;put back changes
	out (contrast_port),a	;update contrast
	ret




colls: .db 33
disphighscore: 
	.db "High-Score",0
dispspeed:
	.db "Speed:",0
dispnewgame:
	.db "New Game",0
dispinfo:
	.db "Contact Info",0
dispclear:
	.db "    ",0
dispclear2:
	.db "              ",0
randsto: .db 0

numb1:
	.db %00001000
	.db %00011000
	.db %00001000
	.db %00001000
	.db %00001000
	.db %00001000
	.db %00001000
	.db %00011100

numb2:
	.db %00111100
	.db %01000010
	.db %00000010
	.db %00000100
	.db %00001000
	.db %00010000
	.db %00100000
	.db %01111110

numb3:
	.db %01111110
	.db %00000100
	.db %00001000
	.db %00000100
	.db %00000010
	.db %00000010
	.db %01000010
	.db %00111100

numb4:
	.db %00000100
	.db %00001100
	.db %00010100
	.db %00100100
	.db %01000100
	.db %01111110
	.db %00000100
	.db %00000100

numb5:
	.db %01111110
	.db %01000000
	.db %01111100
	.db %00000010
	.db %00000010
	.db %00000010
	.db %01000010
	.db %00111100

Title:
;	.db %00000000, %00000000, %00000000, %00000000
;	.db %10001000, %10000100, %00100000, %00000000
;	.db %11001010, %10000100, %00100000, %00000000
;	.db %10101000, %10000100, %00100110, %01111000
;	.db %10101010, %11100111, %00101001, %00010000
;	.db %10101010, %10010100, %10101111, %00110000
;	.db %10011010, %10010100, %10101000, %00100000
;	.db %10001010, %11100111, %00100110, %01111000
infoline1:
.db "My Name, the programer of this game,",0
infoline2:
.db "is Ravneet Singh. If you want to report",0
infoline3:
.db "any Bugs, suggestions or new game",0
infoline4:
.db "ideas,you can e-mail thecheatah@aol.com.",0
infoline5:
.db "",0

Name:
	.db "=====High Score=====",0
BoardSetupName:
	.db "Name:",0
BoardSetupScore:
	.db "Score:",0

Congratulations:
	.db "Congratulations!",0
ugotscore:
	.db "You got a High Score.",0

Tempname:
	.db "              ",0
PlayerScore: .dw 0
currpos: .db 0
titlelives: .db " Lives:",0
titlescore: .db " Score:",0
titledots: .db "Apple:",0
stringtoload: .db 6,"niblvl  "
tempvatstore: .dw $bfff-56
checkisitnibblvl:
	ld hl,stringtoload-1		;
	rst 20h			;copy 10 bytes from hl to op1
	rst 10h
	call _ex_ahl_bde
	call _ahl_plus_2_pg3	;hl points to start of
			;data in program

	call _set_abs_src_addr	;$5285	set that as destination
				; for block copy
	sub a			;AKA ld a,0
	ld hl,storechecknumber		;hl points to data's start address
				;address of string is in
				; relation to 16 bit and ram page
	call _set_abs_dest_addr	;$4647	set that as source for
				; block copy
	xor a			;AKA ld a,0 -it's on already
				; swapped in page (0)
	ld hl,2			;length of data
	call _set_mm_num_bytes	;$464f	set # of bytes to
				; copy in block copy
	call _mm_ldir		;$52ed	ABS block copy
	ld de,(storechecknumber)
	ld hl,1365
	call _cphlde
	ret
storechecknumber: .dw 0
error:
	ld hl,(256*0)+0
	ld (_curRow),hl
	call _clrLCD
	call CloseGray
	call _jforcecmdnochar

nextstring:
	ld b,100
topnextstring:
	ld a,b
	cp 0
	jp z,error
	dec b
	push bc
	call searchvat
	call checkisitnibblvl	
	pop bc
	jr nz,topnextstring

	call LoadString
	call drawalloptions
	ret

searchvat:
	ld a,$0c		;$12 - program
				;$0c - string
	ld hl,(tempvatstore)
	call vatsrch
	jr c,newvat
	ld de,stringtoload
	call copy_to_op1
	ld a,(stringtoload)
	cp 9
	jr nc,vartoobig
	ret
vartoobig:
	ld hl,emptyvat
	ld de,stringtoload
	ld bc,9
	ldir
	ret
newvat:
	ld hl,$bfff-56
	ld (tempvatstore),hl
;	ld de,(currvariable)
	ld hl,emptyvat
	ld bc,9
	ldir

	ret
emptyvat: .db 8,"        "

;==============================================================
; vatsrch
;  searches variable alocation
;  table for certain variable types
; in	hl - where to start searching ($bfff with
;	 ram page 7 swapped in is the
;	 start)
;	a - variable type to search for
; out	hl - the length index byte
;	 of the variable found (stored
;	 backwards! use copy_to_op1 to
;	 put name right way starting at
;	 _op1 found at bottom.)
;	a - variable type
;	d - variable type
;	bc - destroyed (how much if any
;	 vat left)
; by jimi malcolmj1@juno.com
;==============================================================
_RAM_Page_7		=$47f3	;swap in RAM page 7 (variable alocation
				; table)
_PTEMP_END		=$d29a	;3 byte ABS pointer to end of vat
				;if vat page (ram page 7) is swapped
				; in, the second two bytes can be
				; used for 16 bit addressing
vatsrch:			;the actual routine
	call _RAM_Page_7	;swap in RAM page 7 (variable allocation
				; table)
	ld bc,(_PTEMP_END+1)	;second two bytes of ABS pointer
				; to end of vat
		push hl		;save where we're starting from
	or a			;clear the carry flag for our subtraction
				;still retain variable type # to search for
	sbc hl,bc		;since the vat is backwards, we
				; subtract the start from the end to
				; get the length of the vat stored in hl
		pop bc		;get back where we are searching
				;put it in bc temporarily
	ret c			;a carry will mean that where we want
		push bc		;save where we are in vat temporarily
				; to start is after the end of the vat
				; (but really before it in the memory
				; since the vat is backwards)
	ld b,h			;length of vat now in bc
	ld c,l
		pop hl		;get back where we are in vat
	cpdr			;compares (hl) to a, if they are equal
				; it stops, if they are unequal it
				; decreases hl and loops until bc=$0000
	ld (tempvatstore),hl
	ld d,a			;save what type we're searching for
	ld a,b			;get b into accumulator
	or c			;any bits set in b or c make a>=1
				;now on 3rd byte of ABS address of data
	ld a,d			;get back variable type byte
				;load doesn't affect flag status
	jr nz,good_found_one	;if bc>0000 then we found a variable
				; before running out of vat
	scf			;set carry flag like an error message
	ret			;return
good_found_one:
	dec hl			;now on 2nd byte of ABS address of data
	dec hl			;now on 1st byte of ABS address of data
	dec hl			;now we're on the trash byte
	dec hl			;now on length index byte of name!
	ret



;==============================================================
; copy_to_op1
;  turns variable name string
;  that's stored backwards, forwards
;  and stores it starting at de
; in	output of vatsrch!
;	hl - start of variable name index
;	de - where to store name
; out	de - start of variable
;	 name (length indexed). put in
;	 hl if you want to use _vputsn (after you put
;	 length in b and increase de) or _putps
;	hl - byte after variable name
;	b - $00
;	a - (de)
; by jimi malcolmj1@juno.com
;==============================================================
copy_to_op1:
		push de
	ld b,9			;variables have a 10
				; byte max name length
copy_to_op1_loop:
	ld a,(hl)		;get character
	ld (de),a		;store character
	inc de			;increase destination
	dec hl			;decrease source
	djnz copy_to_op1_loop
		pop de
	ret

LoadString:
_ex_ahl_bde		=$45f3	;all our equates needed in
_ahl_plus_2_pg3		=$4c3f	; the program
_set_abs_dest_addr	=$5285
_set_abs_src_addr	=$4647
_set_mm_num_bytes	=$464f
_mm_ldiR		=$52ed

	ld hl,stringtoload-1		;
	rst 20h			;copy 10 bytes from hl to op1
	rst 10h
	jp c,error
	call _ex_ahl_bde
	call _ahl_plus_2_pg3	;hl points to start of
			;data in program

	call _set_abs_src_addr	;$5285	set that as destination
				; for block copy
	sub a			;AKA ld a,0
	ld hl,startlevelcopy		;hl points to data's start address
				;address of string is in
				; relation to 16 bit and ram page
	call _set_abs_dest_addr	;$4647	set that as source for
				; block copy
	xor a			;AKA ld a,0 -it's on already
				; swapped in page (0)
	ld hl,1120			;length of data
	call _set_mm_num_bytes	;$464f	set # of bytes to
				; copy in block copy
	call _mm_ldir		;$52ed	ABS block copy

	ld hl,0
	ld (bigningbyets),hl
	ret

SaveString:
	ret
	ld hl,1365
	ld (bigningbyets),hl


unnoffsave:

	ld hl,stringtoload-1		;copy anything before string for
				; type byte
	rst 20h			;call _Mov10toOP1
	rst 10h			;call _FindSym to see if variable
				; exists
	call nc,_delvar		;delete variable if it exists
				;all necessary info still preserved
	ld hl,endlevelcopy-startlevelcopy	;minus start from end of
					; string so result is length
					; of string
	call _createstrng	;$472f	create string
	call _ex_ahl_bde	;$45f3	ABS bde & ahl swapped
	call _ahl_plus_2_pg3	;$4c3f	increase ABS ahl by two
	call _set_abs_dest_addr	;$5285	set that as destination for
				; block copy
	xor a			;AKA ld a,0
	ld hl,startlevelcopy	;hl points to string_start
				;address of string is in relation
				; to 16 bit and ram page
	call _set_abs_src_addr	;$4647	set that as source for
				; block copy
	xor a			;AKA ld a,0 -it's on already swapped
				; in page (0)
	ld hl,endlevelcopy-startlevelcopy	;length of string
	call _set_mm_num_bytes	;$464f	set # of bytes to copy in
				; block copy
	jp _mm_ldir		;$52ed	ABS block copy
				;we jump instead of calling
				; and returning this way we just use
				; _mm_ldir's ret as ours
				;saves 1 byte

save_game2:
nosave_game2:
	ld hl,_asapvar			;name of current program running
	rst 20h				;copy to OP1
	rst 10h				;_findsym
	ld a,b				;returns bde as prog data
	ld hl,data_start2-_asm_exec_ram+4
					;offset in this program for start
					; of saved game data
					;2 bytes for prog length
					;2 bytes for asm identifier bytes
	add hl,de			;hl=pointer to data in original
					; prog
	adc a,$00			;in case we overlapped pages
					;if carry was set in previous
					; instruction...this will add 1 to
					; a else...it adds 0 to a
	call _set_abs_dest_addr		;set that as the absolute
					; destination address to copy to
	xor a				;no absolute addressing now
	ld hl,data_start2		;*get data from here
	call _set_abs_src_addr		;set that as the absolute source
					; address to copy from
	ld hl,data_end2-data_start2	;*number of bytes to save
	call _set_mm_num_bytes		;set that as the number of bytes
					; to copy
	call _mm_ldir			;perform absolute address data
					; block copy
	jp _clrScrn	



data_start2:
loadnewlevel: .db 1
toloadornot: .db 0;1=continue loading game
currentleveladdress: .dw 0
lives: .db 3
Score: .dw 0
dots: .db 0,0,0

SnakeX: .db 1
SnakeY: .db 1
Snakerestcords1:
	.db 1,1
blockcords2:
	.db 1,1
blockcords3:
	.db 1,1
blockcords4:
	.db 1,1
blockcords5:
	.db 1,1
blockcords6:
	.db 1,1
blockcords7:
	.db 1,1
blockcords8:
	.db 1,1
blockcords9:
	.db 1,1
blockcords10:
	.db 1,1
blockcords11:
	.db 1,1
blockcords12:
	.db 1,1
blockcords13:
	.db 1,1
blockcords14:
	.db 1,1
blockcords15:
	.db 1,1
blockcords16:
	.db 1,1
blockcords17:
	.db 1,1
blockcords18:
	.db 1,1
blockcords19:
	.db 1,1
blockcords20:
	.db 1,1
blockcords21:
	.db 1,1
blockcords22:
	.db 1,1
blockcords23:
	.db 1,1
blockcords24:
	.db 1,1
blockcords25:
	.db 1,1
	.dw 256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256
	.dw 256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256
	.dw 256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256

blockcordsend: .dw 256
pointsneeded: .dw 0
currlevel: .db 1

trueal: .db 0
curroddoreven: .db 0
totest: .db 0
Length: .db 3
Speed: .db 15
direction: .db 3
;0=up
;1=down
;2=left
;3=right

Snakeoddeven .db 0 ;0 = even

SnakeMap:
;0=white block
;1,2=wall
;3,4=snake's boky
;5,6=apple
;7,8=double apple
;9,10=life
	.db 0,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2
	.db 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2
	.db 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2
	.db 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2
	.db 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2
	.db 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2
	.db 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2
	.db 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2
	.db 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2
	.db 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2
	.db 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2
	.db 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2
	.db 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2
	.db 1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2

data_end2:




keychart:
	.db "          XTOJ"
	.db "E   WSNID  ZVR"
	.db "MHC  YUQLGB   "
	.db "=PKFA         "
alphakeychart:
	.db "          xtoj"
	.db "e   wsnid  zvr"
	.db "mhc  yuqlgb   "
	.db "=pkfa         "

loadmap:
	push hl
	call pickurtile


	pop hl
	ld de,SnakeMap
	ld b,56
toptoploadmap:
	push bc 
	push hl
	ld a,(hl);SnakeLevel1
	ld b,8
toploadmap:
		push bc
			push af
			bit 7,a
			jr nz,drawit
			ld a,0
			ld (de),a
skip0:
			ld a,(temploadmap)
			inc a
			ld (temploadmap),a
			pop af
		rla
		inc de
		pop bc
	djnz toploadmap
	pop hl
	inc hl
	pop bc
	djnz toptoploadmap
	ret

drawit:

	ld a,(temploadmap)
	bit 0,a
	jr z,draw1
	ld a,(lefttile)
	ld (de),a
	jr skip0
draw1:
	ld a,(righttile)
	ld (de),a
	jr skip0
temploadmap: .db 0
lefttile: .db 2
righttile: .db 1

startlevelcopy:
bigningbyets: .dw 1365
SnakeLevel1:
.db %11111111,%11111111,%11111111,%11111111
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %11111111,%11111111,%11111111,%11111111
SnakeLevel2:
.db %11111111,%11111111,%11111111,%11111111
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000001,%00100000,%00000010,%01000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000001,%00100000,%00000010,%01000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %11111111,%11111111,%11111111,%11111111
SnakeLevel3:
.db %11111111,%11111111,%11111111,%11111111
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000001,%00100000,%00000100,%10000001
.db %10000001,%00000000,%00000000,%10000001
.db %10000111,%00000000,%00000000,%11100001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000111,%00000000,%00000000,%11100001
.db %10000001,%00000000,%00000000,%10000001
.db %10000001,%00100000,%00000100,%10000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %11111111,%11111111,%11111111,%11111111
SnakeLevel4:
.db %11111111,%11111111,%11111111,%11111111
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000101,%00100000,%00000100,%10100001
.db %10000001,%00000000,%00000000,%10000001
.db %10000111,%00000000,%00000000,%11100001
.db %10000000,%00000001,%10000000,%00000001
.db %10000000,%00000001,%10000000,%00000001
.db %10000111,%00000000,%00000000,%11100001
.db %10000001,%00000000,%00000000,%10000001
.db %10000101,%00100000,%00000100,%10100001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %11111111,%11111111,%11111111,%11111111
SnakeLevel5:
.db %11111111,%11111111,%11111111,%11111111
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000101,%00100001,%00000100,%10100001
.db %10000000,%00000001,%00000000,%10000001
.db %10000111,%00000001,%00000000,%10100001
.db %10000000,%00000001,%11110000,%00000001
.db %10000000,%00001111,%10000000,%00000001
.db %10000101,%00000000,%10000000,%11100001
.db %10000001,%00000000,%10000000,%00000001
.db %10000101,%00100000,%10000100,%10100001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %11111111,%11111111,%11111111,%11111111
SnakeLevel6:
.db %11111111,%11111111,%11111111,%11111111
.db %10000000,%00000000,%00000000,%00000001
.db %10110000,%00000011,%11000000,%00001101
.db %10100000,%00000001,%10000000,%00000101
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10100000,%00000000,%00000000,%00000101
.db %10100000,%00000000,%00000000,%00000101
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10100000,%00000001,%10000000,%00000101
.db %10110000,%00000011,%11000000,%00001101
.db %10000000,%00000000,%00000000,%00000001
.db %11111111,%11111111,%11111111,%11111111
SnakeLevel7:
.db %11111111,%11111111,%11111111,%11111111
.db %10000000,%00000000,%00000000,%00000001
.db %10111000,%00000011,%11000000,%00011101
.db %10100000,%00000001,%10000000,%00000101
.db %10100000,%10000001,%10000001,%00000101
.db %10000000,%00000011,%11000000,%00000001
.db %10100000,%00000000,%00000000,%00000101
.db %10100000,%00000000,%00000000,%00000101
.db %10000000,%00000011,%11000000,%00000001
.db %10100000,%10000001,%10000001,%00000101
.db %10100000,%00000001,%10000000,%00000101
.db %10110000,%00000011,%11000000,%00011101
.db %10000000,%00000000,%00000000,%00000001
.db %11111111,%11111111,%11111111,%11111111
SnakeLevel8:
.db %11111111,%11111111,%11111111,%11111111
.db %10000000,%00000000,%00000000,%00000001
.db %10111000,%00000011,%11000000,%00011101
.db %10100000,%00000001,%10000000,%00000101
.db %10100000,%10000001,%10000001,%00000101
.db %10100000,%00000011,%11000000,%00000101
.db %10100000,%00000000,%01000000,%00000101
.db %10100000,%00000010,%00000000,%00000101
.db %10100000,%00000011,%11000000,%00000101
.db %10100000,%10000001,%10000001,%00000101
.db %10100000,%00000001,%10000000,%00000101
.db %10111000,%00000011,%11000000,%00011101
.db %10000000,%00000000,%00000000,%00000001
.db %11111111,%11111111,%11111111,%11111111
SnakeLevel9:
.db %11111111,%11111111,%11111111,%11111111
.db %10000000,%00000000,%00000000,%00000001
.db %10111001,%11110011,%11001111,%10011101
.db %10100000,%00000001,%10000000,%00000101
.db %10100000,%10000001,%10000001,%00000101
.db %10100000,%00000011,%11000000,%00000101
.db %10100000,%00000000,%01000000,%00000101
.db %10100000,%00000010,%00000000,%00000101
.db %10100000,%00000011,%11000000,%00000101
.db %10100000,%10000001,%10000001,%00000101
.db %10100000,%00000001,%10000000,%00000101
.db %10111001,%11110011,%11001111,%10011101
.db %10000000,%00000000,%00000000,%00000001
.db %11111111,%11111111,%11111111,%11111111
SnakeLevel10:
.db %11111111,%11111111,%11111111,%11111111
.db %10000001,%00000000,%00000000,%10000001
.db %10000001,%00000000,%00000000,%10000001
.db %10000001,%00000000,%00000000,%10000001
.db %10000001,%00000000,%00000000,%10000001
.db %10000001,%10000000,%00000001,%10000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000001,%10000000,%00000001,%10000001
.db %10000001,%00000000,%00000000,%10000001
.db %10000001,%00000000,%00000000,%10000001
.db %10000001,%00000000,%00000000,%10000001
.db %10000001,%00000000,%00000000,%10000001
.db %11111111,%11111111,%11111111,%11111111
SnakeLevel11
.db %11111111,%11111111,%11111111,%11111111
.db %10000001,%00000000,%00000000,%10000001
.db %10000001,%00000000,%00000000,%10000001
.db %10000001,%00000000,%00000000,%10000001
.db %10000001,%00000000,%00000000,%10000001
.db %10000001,%10011001,%10011001,%10000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000001,%10011001,%10011001,%10000001
.db %10000001,%00000000,%00000000,%10000001
.db %10000001,%00000000,%00000000,%10000001
.db %10000001,%00000000,%00000000,%10000001
.db %10000001,%00000000,%00000000,%10000001
.db %11111111,%11111111,%11111111,%11111111
SnakeLevel12
.db %11111111,%11111111,%11111111,%11111111
.db %10000000,%10000000,%00000001,%00000001
.db %10000000,%10000000,%00000001,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%10000000,%00000001,%00000001
.db %10000000,%11111110,%01111111,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%11111110,%01111111,%00000001
.db %10000000,%10000000,%00000001,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%10000000,%00000001,%00000001
.db %10000000,%10000000,%00000001,%00000001
.db %11111111,%11111111,%11111111,%11111111
SnakeLevel13
.db %11111111,%11111111,%11111111,%11111111
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00010000,%00001000,%00000001
.db %10000000,%00100000,%00000100,%00000001
.db %10000000,%01000000,%00000010,%00000001
.db %10000000,%10000000,%00000001,%00000001
.db %10000001,%00000000,%00000000,%10000001
.db %10000010,%00000000,%00000000,%01000001
.db %10000100,%00000000,%00000000,%00100001
.db %10001000,%00000000,%00000000,%00010001
.db %10010000,%00000000,%00000000,%00001001
.db %10100000,%00000000,%00000000,%00000101
.db %10000000,%00000000,%00000000,%00000001
.db %11111111,%11111111,%11111111,%11111111
SnakeLevel14:
.db %11111111,%11111111,%11111111,%11111111
.db %10000001,%00000000,%00000000,%10000001
.db %10000001,%00011010,%01011000,%10000001
.db %10000001,%00100000,%00000100,%10000001
.db %10000000,%01000000,%00000010,%00000001
.db %10000001,%10000000,%00000001,%10000001
.db %10000001,%00000000,%00000000,%10000001
.db %10000010,%00000000,%00000000,%01000001
.db %10000100,%00000000,%00000000,%00100001
.db %10001000,%00000000,%00000000,%00010001
.db %10010000,%00000000,%00000000,%00001001
.db %10100000,%00000000,%00000000,%00000101
.db %10000000,%00000000,%00000000,%00000001
.db %11111111,%11111111,%11111111,%11111111

SnakeLevel15:
.db %11111111,%11111111,%11111111,%11111111
.db %10000000,%00000000,%00000000,%00000001
.db %10111111,%11111111,%11111111,%11111101
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %11000100,%01000100,%01000100,%01000101
.db %10010001,%00010001,%00010001,%00010001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10111111,%11111111,%11111111,%11111101
.db %10000000,%00000000,%00000000,%00000001
.db %11111111,%11111111,%11111111,%11111111

SnakeLevel16:
.db %11111111,%11111111,%11111111,%11111111
.db %10000010,%00000010,%00000010,%00000001
.db %10100000,%01000000,%01000000,%01000001
.db %10000010,%00000010,%00000010,%00000101
.db %10100000,%01000000,%01000000,%01000001
.db %10000010,%00000010,%00000010,%00000101
.db %10100000,%01000000,%01000000,%01000001
.db %10000010,%00000010,%00000010,%00000101
.db %10100000,%01000000,%01000000,%01000001
.db %10000010,%00000010,%00000010,%00000101
.db %10100000,%01000000,%01000000,%01000001
.db %10000010,%00000010,%00000010,%00000101
.db %10000000,%01000000,%01000000,%01000001
.db %11111111,%11111111,%11111111,%11111111

SnakeLevel17:
.db %11111111,%11111111,%11111111,%11111111
.db %10000000,%00000000,%00000000,%00000001
.db %10111111,%00000000,%00000000,%11111101
.db %10100000,%00000000,%00000000,%00000101
.db %10101111,%00000000,%00000000,%11110101
.db %10101111,%00000000,%00000000,%10000101
.db %10100001,%00000000,%00000000,%10111101
.db %10111101,%00000000,%00000000,%10000101
.db %10100001,%00000000,%00000000,%11110101
.db %10101111,%00000000,%00000000,%11110101
.db %10100000,%00000000,%00000000,%00000101
.db %10111111,%00000000,%00000000,%11111101
.db %10000000,%00000000,%00000000,%00000001
.db %11111111,%11111111,%11111111,%11111111

SnakeLevel18:
.db %11111111,%11111111,%11111111,%11111111
.db %10000000,%00011110,%01000000,%00000001
.db %10000000,%00000000,%01000000,%00000001
.db %10000000,%00011110,%01000000,%00000001
.db %10000000,%00000010,%01000000,%00000001
.db %10000000,%00000010,%01000000,%00000001
.db %10000000,%00000010,%01000000,%00000001
.db %10000000,%00000010,%01000000,%00000001
.db %10000000,%00000010,%01000000,%00000001
.db %10000000,%00000010,%01000000,%00000001
.db %10000000,%00000010,%01111000,%00000001
.db %10000000,%00000010,%00000000,%00000001
.db %10000000,%00000010,%11111000,%00000001
.db %11111111,%11111111,%11111111,%11111111

SnakeLevel19:
.db %11111111,%11111111,%11111111,%11111111
.db %10000000,%00000000,%00000000,%00000001
.db %10101010,%10101010,%10101010,%10101001
.db %10000000,%00000000,%00000000,%00000001
.db %10101010,%10101010,%10101010,%10101001
.db %10000000,%00000000,%00000000,%00000001
.db %10101010,%10101010,%10101010,%10101001
.db %10000000,%00000000,%00000000,%00000001
.db %10101010,%10101010,%10101010,%10101001
.db %10000000,%00000000,%00000000,%00000001
.db %10101010,%10101010,%10101010,%10101001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %11111111,%11111111,%11111111,%11111111

SnakeLevel20:
.db %11111111,%11111111,%11111111,%11111111
.db %10000000,%00000000,%00000000,%00000001
.db %10111111,%11111111,%11111111,%11111101
.db %10100000,%00000000,%00000000,%00000101
.db %10101111,%11111110,%01111111,%11110101
.db %10101000,%00000000,%00000000,%00010101
.db %10001000,%00000000,%00000000,%00010001
.db %10001000,%00000000,%00000000,%00010001
.db %10101000,%00000000,%00000000,%00010101
.db %10101111,%11111110,%01111111,%11110101
.db %10100000,%00000000,%00000000,%00000101
.db %10111111,%11111111,%11111111,%11111101
.db %10000000,%00000000,%00000000,%00000001
.db %11111111,%11111111,%11111111,%11111111
endlevelcopy

data_start:
Score1:
	.db "Ravneet Singh!",0
Score1r:
	.dw 2000
Score2:
	.db "Ravneet Singh!",0
Score2r:
	.dw 1750
Score3:
	.db "Ravneet Singh!",0
Score3r:
	.dw 1250
Score4:
	.db "Ravneet Singh!",0
Score4r:
	.dw 1000
Score5:
	.db "Ravneet Singh!",0
Score5r:
	.dw 800
Score6:
	.db "Ravneet Singh!",0
Score6r:
	.dw 600
Score7:
	.db "Ravneet Singh!",0
Score7r:
	.dw 400
Score8:
	.db "Ravneet Singh!",0
Score8r:
	.dw 200
maxusermap: .db 1

data_end:

tile0:
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000

tile1:
	.db %00010000
	.db %01110000
	.db %01110000
	.db %11110000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %11110000
	.db %10010000
	.db %10010000
	.db %11110000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000

tile2:
	.db %00000001
	.db %00000111
	.db %00000111
	.db %00001111
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00001111
	.db %00001001
	.db %00001001
	.db %00001111
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000

tile3:
	.db %11110000
	.db %11110000
	.db %11110000
	.db %11110000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %11110000
	.db %10010000
	.db %10010000
	.db %11110000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000

tile4:
	.db %00001111
	.db %00001111
	.db %00001111
	.db %00001111
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00001111
	.db %00001001
	.db %00001001
	.db %00001111
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000

tile5:
	.db %11100000
	.db %11010000
	.db %10010000
	.db %01100000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %11000000
	.db %00100000
	.db %01100000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000

tile6:
	.db %00000111
	.db %00001011
	.db %00001001
	.db %00000110
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000011
	.db %00000100
	.db %00000110
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000

tile7:
	.db %11000000
	.db %00100000
	.db %01100000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %11100000
	.db %11010000
	.db %10010000
	.db %01100000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000

tile8:
	.db %00000011
	.db %00000100
	.db %00000110
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000111
	.db %00001011
	.db %00001001
	.db %00000110
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000

tile9:
	.db %01100000
	.db %10010000
	.db %10010000
	.db %01100000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %01100000
	.db %01100000
	.db %01100000
	.db %01100000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000

tile10:
	.db %00000110
	.db %00001001
	.db %00001001
	.db %00000110
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00001111
	.db %00001111
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
brickstart:
tile11:
	.db %11110000
	.db %00010000
	.db %11110000
	.db %01000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %11100000
	.db %00000000
	.db %10110000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000

tile12:
	.db %00001111
	.db %00000001
	.db %00001111
	.db %00000100
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00001110
	.db %00000000
	.db %00001011
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
brickend:

crosstart:
tile13:
	.db %01000000
	.db %11110000
	.db %01100000
	.db %01000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %11110000
	.db %11110000
	.db %11010000
	.db %11110000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000

tile14:
	.db %00000010
	.db %00001111
	.db %00000110
	.db %00000010
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00001111
	.db %00001111
	.db %00001011
	.db %00001111
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
crossend:

windowstart:
tile15:
	.db %00010000
	.db %01110000
	.db %01110000
	.db %11110000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %11110000
	.db %10010000
	.db %10010000
	.db %11110000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000

tile16:
	.db %00000001
	.db %00000111
	.db %00000111
	.db %00001111
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00001111
	.db %00001001
	.db %00001001
	.db %00001111
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
windowend:
eeestart:

tile17:
	.db %11110000
	.db %10010000
	.db %10010000
	.db %11110000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %01100000
	.db %11110000
	.db %11110000
	.db %01100000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000

tile18:
	.db %00001111
	.db %00001001
	.db %00001001
	.db %00001111
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000110
	.db %00001111
	.db %00001111
	.db %00000110
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
eeeend:
pickurtile:
	ld a,(currlevel)
	cp 6
	jr c,loadwindowtile
	cp 11
	jr c,loadeeetile
	cp 16
	jr c,loadcrosstile
	ld hl,tile11
	ld de,tile1
	ld bc,32
	ldir
	ret

loadeeetile:
	ld hl,tile17
	ld de,tile1
	ld bc,32
	ldir
	ret


loadcrosstile:
	ld hl,tile13
	ld de,tile1
	ld bc,32
	ldir
	ret

loadwindowtile:
	ld hl,tile15
	ld de,tile1
	ld bc,32
	ldir
	ret


;de=map
;hl=address
DrawGray:
	push hl
	ld bc,$fc00
	add hl,bc
	ld b,8
topDrawGray:
	push bc
	ld a,(de)
	ld b,a
	ld a,(hl)
	or b
	ld (hl),a
	inc de
	ld bc,$10
	add hl,bc
	pop bc
	djnz topDrawGray
	pop hl


	ld bc,$ca00
	add hl,bc
	ld b,4
topDrawGray1:
	push bc
	ld a,(de)
	ld b,a
	ld a,(hl)
	or b
	ld (hl),a
	inc de
	ld bc,$10
	add hl,bc
	pop bc
	djnz topDrawGray1
	ret
int_addr equ $F8F8                      ;Start of interrupt code


CloseGray:
 ld hl, SixBytes
 ld de, $ce00
 ld bc, 6
 ldir
 im 1
 ld a,$3c
 out (0),a
 call _clrLCD
 ret

SixBytes: .db 0,0,0,0,0,0
OpenGray:
 ld hl,$ce00
 ld de, SixBytes
 ld bc, 6
 ldir

 ld hl,$FA00                            ;Source = $FA00 (Start of vector table)
 ld de,$FA01                            ;Destination = $FA01
 ld (hl),$F8                            ;Set first byte so it is copied to all of them ($F8F8)
 ld bc,257                              ;257 bytes (size of vector table)
 ldir                                   ;(DE) <- (HL), BC=BC-1, Loop till B=0
 
 ld hl,int_copy                         ;Source = interrupt routine
 ld de,int_addr                         ;Destination = $F8F8 (as specified in vector table)
 ld bc,int_end-int_start                ;Length of custom interrupt routine
 ldir                                   ;(DE) <- (HL), BC=BC-1, Loop till B=0

 ld a,$FA                               ;Set up address of vector table
 ld i,a                                 ; MSB = $FA
                                        ; LSB = (byte supplied by data bus - random)
 im 2                                   ;Set interrupt mode 2

 ret                                    ;Return

int_copy:
 .org int_addr                          ;Set instruction counter to $F8F8 (start of int handler)

int_start:
 ex af,af'                              ;Exchange af with alternate register af'
 exx                                    

 in a,(3)
 bit 1,a
 jp z,$66

 call incmaingamecounter

 ld a,(test)
 cp 2
 jr z,next

 ld a,(test)
 inc a
 ld (test),a

 ld a,60
 out (0),a

 jp $66              ;jump to normal handler so it can do its things

next:
 ld a,0
 ld (test),a

 ld a,$a
 out (0),a

 jp $66              ;jump to normal handler so it can do its things


test: .db 0

int_end:

.org _asm_exec_ram+7000
tempstore: 
.end
